delta	= $57
volsav	= $59
tstart	= $5a
noteptr	= $5c
time	= $a0
vicbase	= $9000

	* = $1201

	; BASIC loader
	.byt $0c,$10,$0a,$00,$9e,$30,$34,$36,$32,$34,$00,$00,$00,$00,$00

start
	; initialize the note pointer
	lda #<cancan
	sta noteptr
	lda #>cancan
	sta noteptr+1

	; save the starting time
	sei
	lda time+2
	sta tstart
	lda time+1
	sta tstart+1
	cli

loop
	; do other stuff here

	jsr play		; play the next note
	bcc loop		; continue with the next note
	bcs start		; start tune again

play
	; check for end
	ldy #0
	lda (noteptr),y
	cmp #$ff
	bne cont
	iny
	lda (noteptr),y
	dey
	cmp #$ff
	bne cont

	; end of tune
	sec
	rts

cont
	; calculate time delta from start
	sec
	sei
	lda time+2
	sbc tstart
	sta delta
	lda time+1
	cli
	sbc tstart+1
	sta delta+1

cmpnote
	; compare with next time offset
	ldy #1
	lda delta+1
	cmp (noteptr),y
	bcc out			; time not yet reached
	lda delta
	dey
	cmp (noteptr),y
	bcc out			; time not yet reached

	; note is to be played now
	iny
	iny
	lda (noteptr),y		; get register
	beq vol

	;  voice register change
	tax
	iny
	lda (noteptr),y		; get value
	sta vicbase,x
	jmp cont2

vol
	; volume register change
	lda vicbase+$0e
	and #$f0
	sta volsav
	iny
	lda (noteptr),y		; get value
	ora volsav
	sta vicbase+$0e

cont2
	; increment note pointer to next note
	lda noteptr
	clc
	adc #4
	sta noteptr
	lda noteptr+1
	adc #0
	sta noteptr+1
	jmp cmpnote

out	clc
	rts

	; tune data

	; initial word is the time offset from the start of the tune this
	; event occurs, $FFFF = end of tune
	; first byte is the LSB of the VIC register, $00 = volume; second byte
	; is the register value

cancan
	.word 0
	.byte $00,15
	.word 5
	.byte $0c,151
	.word 14
	.byte $0c,0
	.word 16
	.byte $0c,185
	.word 26
	.byte $0c,0
	.word 28
	.byte $0c,185
	.word 37
	.byte $0c,0
	.word 40
	.byte $0c,193
	.word 49
	.byte $0c,0
	.word 51
	.byte $0c,185
	.word 60
	.byte $0c,0
	.word 62
	.byte $0c,177
	.word 72
	.byte $0c,0
	.word 74
	.byte $0c,177
	.word 84
	.byte $0c,0
	.word 85
	.byte $0c,193
	.word 95
	.byte $0c,0
	.word 97
	.byte $0c,196
	.word 107
	.byte $0c,0
	.word 109
	.byte $0c,209
	.word 119
	.byte $0c,0
	.word 120
	.byte $0c,216
	.word 131
	.byte $0c,0
	.word 132
	.byte $0c,209
	.word 142
	.byte $0c,0
	.word 144
	.byte $0c,209
	.word 154
	.byte $0c,0
	.word 155
	.byte $0c,203
	.word 166
	.byte $0c,0
	.word 167
	.byte $0c,203
	.word 188
	.byte $0c,0
	.word 190
	.byte $0c,209
	.word 200
	.byte $0c,0
	.word 202
	.byte $0c,172
	.word 211
	.byte $0c,0
	.word 214
	.byte $0c,172
	.word 223
	.byte $0c,0
	.word 224
	.byte $0c,209
	.word 235
	.byte $0c,0
	.word 236
	.byte $0c,203
	.word 246
	.byte $0c,0
	.word 248
	.byte $0c,177
	.word 258
	.byte $0c,0
	.word 259
	.byte $0c,177
	.word 270
	.byte $0c,0
	.word 271
	.byte $0c,193
	.word 281
	.byte $0c,0
	.word 283
	.byte $0c,193
	.word 293
	.byte $0c,0
	.word 294
	.byte $0c,185
	.word 305
	.byte $0c,0
	.word 306
	.byte $0c,193
	.word 315
	.byte $0c,0
	.word 318
	.byte $0c,185
	.word 327
	.byte $0c,0
	.word 329
	.byte $0c,193
	.word 339
	.byte $0c,0
	.word 341
	.byte $0c,185
	.word 350
	.byte $0c,0
	.word 353
	.byte $0c,193
	.word 362
	.byte $0c,0
	.word 363
	.byte $0c,185
	.word 374
	.byte $0c,0
	.word 378
	.byte $0c,151
	.word 387
	.byte $0c,0
	.word 389
	.byte $0c,185
	.word 399
	.byte $0c,0
	.word 401
	.byte $0c,185
	.word 410
	.byte $0c,0
	.word 413
	.byte $0c,193
	.word 422
	.byte $0c,0
	.word 423
	.byte $0c,185
	.word 434
	.byte $0c,0
	.word 435
	.byte $0c,177
	.word 445
	.byte $0c,0
	.word 447
	.byte $0c,177
	.word 457
	.byte $0c,0
	.word 458
	.byte $0c,193
	.word 469
	.byte $0c,0
	.word 470
	.byte $0c,196
	.word 480
	.byte $0c,0
	.word 482
	.byte $0c,209
	.word 492
	.byte $0c,0
	.word 493
	.byte $0c,216
	.word 504
	.byte $0c,0
	.word 505
	.byte $0c,209
	.word 515
	.byte $0c,0
	.word 517
	.byte $0c,209
	.word 526
	.byte $0c,0
	.word 528
	.byte $0c,203
	.word 538
	.byte $0c,0
	.word 540
	.byte $0c,203
	.word 561
	.byte $0c,0
	.word 562
	.byte $0c,209
	.word 573
	.byte $0c,0
	.word 574
	.byte $0c,172
	.word 584
	.byte $0c,0
	.word 586
	.byte $0c,172
	.word 596
	.byte $0c,0
	.word 597
	.byte $0c,209
	.word 608
	.byte $0c,0
	.word 609
	.byte $0c,203
	.word 619
	.byte $0c,0
	.word 621
	.byte $0c,177
	.word 631
	.byte $0c,0
	.word 633
	.byte $0c,177
	.word 643
	.byte $0c,0
	.word 644
	.byte $0c,193
	.word 654
	.byte $0c,0
	.word 656
	.byte $0c,193
	.word 666
	.byte $0c,0
	.word 668
	.byte $0c,185
	.word 678
	.byte $0c,0
	.word 679
	.byte $0c,193
	.word 690
	.byte $0c,0
	.word 691
	.byte $0c,185
	.word 700
	.byte $0c,0
	.word 703
	.byte $0c,177
	.word 724
	.byte $0c,0
	.word 726
	.byte $0c,177
	.word 747
	.byte $0c,0
	.word 751
	.byte $0c,193
	.word 772
	.byte $0c,0
	.word 775
	.byte $0c,177
	.word 795
	.byte $0c,0
	.word 798
	.byte $0c,162
	.word 819
	.byte $0c,0
	.word 820
	.byte $0c,151
	.word 842
	.byte $0c,0
	.word 844
	.byte $0c,203
	.word 854
	.byte $0c,0
	.word 856
	.byte $0c,185
	.word 866
	.byte $0c,0
	.word 867
	.byte $0c,193
	.word 877
	.byte $0c,0
	.word 879
	.byte $0c,196
	.word 889
	.byte $0c,0
	.word 891
	.byte $0c,193
	.word 901
	.byte $0c,0
	.word 902
	.byte $0c,185
	.word 911
	.byte $0c,0
	.word 914
	.byte $0c,177
	.word 935
	.byte $0c,0
	.word 937
	.byte $0c,193
	.word 958
	.byte $0c,0
	.word 961
	.byte $0c,177
	.word 982
	.byte $0c,0
	.word 983
	.byte $0c,162
	.word 1005
	.byte $0c,0
	.word 1007
	.byte $0c,151
	.word 1029
	.byte $0c,0
	.word 1030
	.byte $0c,145
	.word 1040
	.byte $0c,0
	.word 1042
	.byte $0c,151
	.word 1052
	.byte $0c,0
	.word 1054
	.byte $0c,162
	.word 1064
	.byte $0c,0
	.word 1065
	.byte $0c,172
	.word 1076
	.byte $0c,0
	.word 1077
	.byte $0c,177
	.word 1086
	.byte $0c,0
	.word 1089
	.byte $0c,151
	.word 1098
	.byte $0c,0
	.word 1100
	.byte $0c,172
	.word 1110
	.byte $0c,0
	.word 1112
	.byte $0c,151
	.word 1121
	.byte $0c,0
	.word 1125
	.byte $0c,177
	.word 1135
	.byte $0c,0
	.word 1137
	.byte $0c,151
	.word 1146
	.byte $0c,0
	.word 1149
	.byte $0c,172
	.word 1158
	.byte $0c,0
	.word 1160
	.byte $0c,151
	.word 1169
	.byte $0c,0
	.word 1172
	.byte $0c,177
	.word 1181
	.byte $0c,0
	.word 1184
	.byte $0c,151
	.word 1193
	.byte $0c,0
	.word 1194
	.byte $0c,172
	.word 1204
	.byte $0c,0
	.word 1206
	.byte $0c,151
	.word 1216
	.byte $0c,0
	.word 1218
	.byte $0c,177
	.word 1228
	.byte $0c,0
	.word 1229
	.byte $0c,177
	.word 1234
	.byte $0c,0
	.word 1235
	.byte $0c,177
	.word 1239
	.byte $0c,0
	.word 1241
	.byte $0c,177
	.word 1251
	.byte $0c,0
	.word 1252
	.byte $0c,177
	.word 1263
	.byte $0c,0
	.word 1264
	.byte $0c,177
	.word 1274
	.byte $0c,0
	.word 1276
	.byte $0c,177
	.word 1286
	.byte $0c,0
	.word 1287
	.byte $0c,177
	.word 1298
	.byte $0c,0
	.word 1299
	.byte $0c,177
	.word 1308
	.byte $0c,0
	.word 1311
	.byte $0c,177
	.word 1320
	.byte $0c,0
	.word 1322
	.byte $0c,177
	.word 1332
	.byte $0c,0
	.word 1333
	.byte $0c,177
	.word 1343
	.byte $0c,0
	.word 1345
	.byte $0c,177
	.word 1355
	.byte $0c,0
	.word 1356
	.byte $0c,177
	.word 1367
	.byte $0c,0
	.word 1368
	.byte $0c,177
	.word 1378
	.byte $0c,0
	.word 1380
	.byte $0c,177
	.word 1390
	.byte $0c,0
	.word 1391
	.byte $0c,177
	.word 1401
	.byte $0c,0
	.word 1404
	.byte $0c,138
	.word 1450
	.byte $0c,0
	.word 1451
	.byte $0c,151
	.word 1462
	.byte $0c,0
	.word 1463
	.byte $0c,167
	.word 1473
	.byte $0c,0
	.word 1475
	.byte $0c,162
	.word 1485
	.byte $0c,0
	.word 1486
	.byte $0c,151
	.word 1497
	.byte $0c,0
	.word 1498
	.byte $0c,177
	.word 1519
	.byte $0c,0
	.word 1522
	.byte $0c,177
	.word 1543
	.byte $0c,0
	.word 1545
	.byte $0c,177
	.word 1554
	.byte $0c,0
	.word 1557
	.byte $0c,185
	.word 1566
	.byte $0c,0
	.word 1567
	.byte $0c,162
	.word 1578
	.byte $0c,0
	.word 1579
	.byte $0c,167
	.word 1589
	.byte $0c,0
	.word 1591
	.byte $0c,151
	.word 1613
	.byte $0c,0
	.word 1614
	.byte $0c,151
	.word 1636
	.byte $0c,0
	.word 1638
	.byte $0c,151
	.word 1648
	.byte $0c,0
	.word 1649
	.byte $0c,167
	.word 1660
	.byte $0c,0
	.word 1661
	.byte $0c,162
	.word 1671
	.byte $0c,0
	.word 1673
	.byte $0c,151
	.word 1682
	.byte $0c,0
	.word 1684
	.byte $0c,138
	.word 1694
	.byte $0c,0
	.word 1696
	.byte $0c,196
	.word 1705
	.byte $0c,0
	.word 1708
	.byte $0c,193
	.word 1717
	.byte $0c,0
	.word 1718
	.byte $0c,185
	.word 1729
	.byte $0c,0
	.word 1730
	.byte $0c,177
	.word 1740
	.byte $0c,0
	.word 1742
	.byte $0c,167
	.word 1752
	.byte $0c,0
	.word 1754
	.byte $0c,162
	.word 1764
	.byte $0c,0
	.word 1765
	.byte $0c,151
	.word 1775
	.byte $0c,0
	.word 1778
	.byte $0c,138
	.word 1824
	.byte $0c,0
	.word 1825
	.byte $0c,151
	.word 1836
	.byte $0c,0
	.word 1837
	.byte $0c,167
	.word 1847
	.byte $0c,0
	.word 1849
	.byte $0c,162
	.word 1859
	.byte $0c,0
	.word 1861
	.byte $0c,151
	.word 1871
	.byte $0c,0
	.word 1872
	.byte $0c,177
	.word 1893
	.byte $0c,0
	.word 1896
	.byte $0c,177
	.word 1917
	.byte $0c,0
	.word 1919
	.byte $0c,177
	.word 1928
	.byte $0c,0
	.word 1931
	.byte $0c,185
	.word 1940
	.byte $0c,0
	.word 1941
	.byte $0c,162
	.word 1952
	.byte $0c,0
	.word 1953
	.byte $0c,167
	.word 1963
	.byte $0c,0
	.word 1965
	.byte $0c,151
	.word 1987
	.byte $0c,0
	.word 1988
	.byte $0c,151
	.word 2010
	.byte $0c,0
	.word 2012
	.byte $0c,151
	.word 2022
	.byte $0c,0
	.word 2023
	.byte $0c,167
	.word 2033
	.byte $0c,0
	.word 2035
	.byte $0c,162
	.word 2045
	.byte $0c,0
	.word 2047
	.byte $0c,151
	.word 2057
	.byte $0c,0
	.word 2058
	.byte $0c,138
	.word 2067
	.byte $0c,0
	.word 2070
	.byte $0c,177
	.word 2079
	.byte $0c,0
	.word 2081
	.byte $0c,151
	.word 2091
	.byte $0c,0
	.word 2093
	.byte $0c,162
	.word 2102
	.byte $0c,0
	.word 2105
	.byte $0c,138
	.word 2126
	.byte $0c,0
	.word 2127
	.byte $0c,177
	.word 2149
	.byte $0c,0
	.word 2153
	.byte $0c,138
	.word 2198
	.byte $0c,0
	.word 2199
	.byte $0c,151
	.word 2210
	.byte $0c,0
	.word 2211
	.byte $0c,167
	.word 2221
	.byte $0c,0
	.word 2223
	.byte $0c,162
	.word 2233
	.byte $0c,0
	.word 2234
	.byte $0c,151
	.word 2245
	.byte $0c,0
	.word 2246
	.byte $0c,177
	.word 2268
	.byte $0c,0
	.word 2269
	.byte $0c,177
	.word 2290
	.byte $0c,0
	.word 2293
	.byte $0c,177
	.word 2302
	.byte $0c,0
	.word 2305
	.byte $0c,185
	.word 2314
	.byte $0c,0
	.word 2316
	.byte $0c,162
	.word 2326
	.byte $0c,0
	.word 2328
	.byte $0c,167
	.word 2337
	.byte $0c,0
	.word 2340
	.byte $0c,151
	.word 2361
	.byte $0c,0
	.word 2362
	.byte $0c,151
	.word 2384
	.byte $0c,0
	.word 2386
	.byte $0c,151
	.word 2396
	.byte $0c,0
	.word 2397
	.byte $0c,167
	.word 2408
	.byte $0c,0
	.word 2409
	.byte $0c,162
	.word 2419
	.byte $0c,0
	.word 2421
	.byte $0c,151
	.word 2431
	.byte $0c,0
	.word 2432
	.byte $0c,138
	.word 2443
	.byte $0c,0
	.word 2444
	.byte $0c,196
	.word 2454
	.byte $0c,0
	.word 2456
	.byte $0c,193
	.word 2465
	.byte $0c,0
	.word 2467
	.byte $0c,185
	.word 2477
	.byte $0c,0
	.word 2479
	.byte $0c,177
	.word 2488
	.byte $0c,0
	.word 2491
	.byte $0c,167
	.word 2500
	.byte $0c,0
	.word 2502
	.byte $0c,162
	.word 2512
	.byte $0c,0
	.word 2514
	.byte $0c,151
	.word 2523
	.byte $0c,0
	.word 2527
	.byte $0c,138
	.word 2572
	.byte $0c,0
	.word 2573
	.byte $0c,151
	.word 2583
	.byte $0c,0
	.word 2585
	.byte $0c,167
	.word 2595
	.byte $0c,0
	.word 2597
	.byte $0c,162
	.word 2607
	.byte $0c,0
	.word 2608
	.byte $0c,151
	.word 2618
	.byte $0c,0
	.word 2620
	.byte $0c,177
	.word 2642
	.byte $0c,0
	.word 2643
	.byte $0c,177
	.word 2664
	.byte $0c,0
	.word 2667
	.byte $0c,177
	.word 2676
	.byte $0c,0
	.word 2678
	.byte $0c,185
	.word 2688
	.byte $0c,0
	.word 2690
	.byte $0c,162
	.word 2699
	.byte $0c,0
	.word 2702
	.byte $0c,167
	.word 2711
	.byte $0c,0
	.word 2712
	.byte $0c,151
	.word 2735
	.byte $0c,0
	.word 2736
	.byte $0c,151
	.word 2758
	.byte $0c,0
	.word 2760
	.byte $0c,151
	.word 2770
	.byte $0c,0
	.word 2771
	.byte $0c,167
	.word 2781
	.byte $0c,0
	.word 2783
	.byte $0c,162
	.word 2793
	.byte $0c,0
	.word 2795
	.byte $0c,151
	.word 2805
	.byte $0c,0
	.word 2806
	.byte $0c,138
	.word 2816
	.byte $0c,0
	.word 2818
	.byte $0c,177
	.word 2828
	.byte $0c,0
	.word 2830
	.byte $0c,151
	.word 2839
	.byte $0c,0
	.word 2841
	.byte $0c,162
	.word 2850
	.byte $0c,0
	.word 2853
	.byte $0c,138
	.word 2897
	.byte $0c,0
	.word $ffff
